/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.glue;

import javax.annotation.Generated;

import com.amazonaws.services.glue.model.*;
import com.amazonaws.*;

/**
 * Abstract implementation of {@code AWSGlue}. Convenient method forms pass through to the corresponding overload that
 * takes a request object, which throws an {@code UnsupportedOperationException}.
 */
@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class AbstractAWSGlue implements AWSGlue {

    protected AbstractAWSGlue() {
    }

    @Override
    public BatchCreatePartitionResult batchCreatePartition(BatchCreatePartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public BatchDeleteConnectionResult batchDeleteConnection(BatchDeleteConnectionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public BatchDeletePartitionResult batchDeletePartition(BatchDeletePartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public BatchDeleteTableResult batchDeleteTable(BatchDeleteTableRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public BatchDeleteTableVersionResult batchDeleteTableVersion(BatchDeleteTableVersionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public BatchGetPartitionResult batchGetPartition(BatchGetPartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public BatchStopJobRunResult batchStopJobRun(BatchStopJobRunRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateClassifierResult createClassifier(CreateClassifierRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateConnectionResult createConnection(CreateConnectionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateCrawlerResult createCrawler(CreateCrawlerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateDatabaseResult createDatabase(CreateDatabaseRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateDevEndpointResult createDevEndpoint(CreateDevEndpointRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateJobResult createJob(CreateJobRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreatePartitionResult createPartition(CreatePartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateScriptResult createScript(CreateScriptRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateTableResult createTable(CreateTableRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateTriggerResult createTrigger(CreateTriggerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public CreateUserDefinedFunctionResult createUserDefinedFunction(CreateUserDefinedFunctionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteClassifierResult deleteClassifier(DeleteClassifierRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteConnectionResult deleteConnection(DeleteConnectionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteCrawlerResult deleteCrawler(DeleteCrawlerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteDatabaseResult deleteDatabase(DeleteDatabaseRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteDevEndpointResult deleteDevEndpoint(DeleteDevEndpointRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteJobResult deleteJob(DeleteJobRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeletePartitionResult deletePartition(DeletePartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteTableResult deleteTable(DeleteTableRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteTableVersionResult deleteTableVersion(DeleteTableVersionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteTriggerResult deleteTrigger(DeleteTriggerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public DeleteUserDefinedFunctionResult deleteUserDefinedFunction(DeleteUserDefinedFunctionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetCatalogImportStatusResult getCatalogImportStatus(GetCatalogImportStatusRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetClassifierResult getClassifier(GetClassifierRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetClassifiersResult getClassifiers(GetClassifiersRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetConnectionResult getConnection(GetConnectionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetConnectionsResult getConnections(GetConnectionsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetCrawlerResult getCrawler(GetCrawlerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetCrawlerMetricsResult getCrawlerMetrics(GetCrawlerMetricsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetCrawlersResult getCrawlers(GetCrawlersRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetDatabaseResult getDatabase(GetDatabaseRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetDatabasesResult getDatabases(GetDatabasesRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetDataflowGraphResult getDataflowGraph(GetDataflowGraphRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetDevEndpointResult getDevEndpoint(GetDevEndpointRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetDevEndpointsResult getDevEndpoints(GetDevEndpointsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetJobResult getJob(GetJobRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetJobRunResult getJobRun(GetJobRunRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetJobRunsResult getJobRuns(GetJobRunsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetJobsResult getJobs(GetJobsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetMappingResult getMapping(GetMappingRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetPartitionResult getPartition(GetPartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetPartitionsResult getPartitions(GetPartitionsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetPlanResult getPlan(GetPlanRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetTableResult getTable(GetTableRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetTableVersionResult getTableVersion(GetTableVersionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetTableVersionsResult getTableVersions(GetTableVersionsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetTablesResult getTables(GetTablesRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetTriggerResult getTrigger(GetTriggerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetTriggersResult getTriggers(GetTriggersRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetUserDefinedFunctionResult getUserDefinedFunction(GetUserDefinedFunctionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public GetUserDefinedFunctionsResult getUserDefinedFunctions(GetUserDefinedFunctionsRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public ImportCatalogToGlueResult importCatalogToGlue(ImportCatalogToGlueRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public ResetJobBookmarkResult resetJobBookmark(ResetJobBookmarkRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StartCrawlerResult startCrawler(StartCrawlerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StartCrawlerScheduleResult startCrawlerSchedule(StartCrawlerScheduleRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StartJobRunResult startJobRun(StartJobRunRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StartTriggerResult startTrigger(StartTriggerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StopCrawlerResult stopCrawler(StopCrawlerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StopCrawlerScheduleResult stopCrawlerSchedule(StopCrawlerScheduleRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public StopTriggerResult stopTrigger(StopTriggerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateClassifierResult updateClassifier(UpdateClassifierRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateConnectionResult updateConnection(UpdateConnectionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateCrawlerResult updateCrawler(UpdateCrawlerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateCrawlerScheduleResult updateCrawlerSchedule(UpdateCrawlerScheduleRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateDatabaseResult updateDatabase(UpdateDatabaseRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateDevEndpointResult updateDevEndpoint(UpdateDevEndpointRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateJobResult updateJob(UpdateJobRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdatePartitionResult updatePartition(UpdatePartitionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateTableResult updateTable(UpdateTableRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateTriggerResult updateTrigger(UpdateTriggerRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public UpdateUserDefinedFunctionResult updateUserDefinedFunction(UpdateUserDefinedFunctionRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public void shutdown() {
        throw new java.lang.UnsupportedOperationException();
    }

    @Override
    public com.amazonaws.ResponseMetadata getCachedResponseMetadata(com.amazonaws.AmazonWebServiceRequest request) {
        throw new java.lang.UnsupportedOperationException();
    }

}
